<?php

require_once("include_main.php");

function backup() {
    $post = "post";
    $backup = new MainBackup();
    global $mainSession;
    echo $backup->getDate().": starting backup script\n";
    if($mainSession->webCfg->error != "") {
        return $backup->error($mainSession->webCfg->error, $post);
    }
    if($mainSession->webCfg->backupUrl == "") {
        return $backup->error("no backup url defined", $post);
    }
    // get backup script from backup url
    $urlParts = parse_url($mainSession->webCfg->backupUrl);
    $localFile = false;
    exec("/sbin/ifconfig eth0 | grep inet | awk '{print $2}' | sed -e 's/Adresse://' -e 's/addr://'",$serverAddr);
    if($urlParts["host"] == $serverAddr[0] || $urlParts["host"] == "127.0.0.1") {  // try to get local file
        if(file_exists(Config::webRoot.$urlParts["path"])) {
            $localFile = true;
            $response = file_get_contents(Config::webRoot.$urlParts["path"]);
        }
    }
    if(!$localFile) {
        $c = curl_init();
        curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($c, CURLOPT_SSL_VERIFYPEER, true);
        curl_setopt($c, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($c, CURLOPT_FOLLOWLOCATION, true);
        curl_setopt($c, CURLOPT_MAXREDIRS, 4);
        curl_setopt($c, CURLOPT_CAPATH, Config::certDirTrusted);
        curl_setopt($c, CURLOPT_SSLCERT, Config::certServer);
        curl_setopt($c, CURLOPT_URL, $mainSession->webCfg->backupUrl);
        //curl_setopt($c, CURLOPT_HEADER, true);
        if(($authUrl = $mainSession->webCfg->getAuth($mainSession->webCfg->backupUrl)) != null) {
            //do_log($authUrl->url." ".$authUrl->pw." ".$authUrl->user);
            curl_setopt($c, CURLOPT_HTTPAUTH, CURLAUTH_ANY);
            curl_setopt($c, CURLOPT_USERPWD, "{$authUrl->user}:{$authUrl->pw}");
        }
        $response = curl_exec($c);
        $error = check_response($response, $c, $errorNo);
        curl_close($c);
        if($error !== false ) {
            if($errorNo == 60) {
                if(Certificates::getServerCertificate($mainSession->webCfg->backupUrl, $error) === false) {
                    send_alarm("Certificate error", $error, Alarms::alCertError);
                    return $backup->error($error, $post);
                }
                else {
                    clear_alarm (Alarms::alCertError);
                    send_alarm("Certificate Rejected", "Server certificate for update script rejected, look at your SSL reject list", Alarms::alCertRejected);
                    return $backup->error("Server certificate for update script rejected, look at your SSL reject list", $post);
                }
            }
            else {
                clear_alarm (Alarms::alCertError);
                clear_alarm (Alarms::alCertRejected);
                send_alarm("Retrieving backup script failed", $error, Alarms::alRetrieveBackupScript);
                return $backup->error("Retrieving backup script failed: $error", $post);
            }                
        }
        else {
            clear_alarm (Alarms::alCertError);
            clear_alarm (Alarms::alCertRejected);
            clear_alarm (Alarms::alRetrieveBackupScript);
        }
    }
    $response = str_replace("\r", "", $response);
    $lines = explode("\n", $response);
    //echo htmlentities($response);
    $allowedTime = true;
    $timeCmd = false;
    foreach($lines as $line) {
        if(strpos($line, "#") !== 0 && trim($line, " ") !== "") {
            $cmd = explode(" ", $line, 3);
            $cmd[1] = rtrim($cmd[1], " ");
            $error = "";
            switch($cmd[0]) {
                case MainBackup::saveInnovaphoneCfgs:
                    if($allowedTime) {
                        $executeBackup = true;
                        if($timeCmd === true && file_exists(Config::webRoot."/".Config::tmpBackupSerials.MainBackup::saveInnovaphoneCfgs)) {
                            $contentFile = file(Config::webRoot."/".Config::tmpBackupSerials.MainBackup::saveInnovaphoneCfgs);
                            $actualTime = $backup->getDate();
                            $fileTime = $contentFile[1];
                            if(!strncmp($actualTime, $fileTime, 14))
                                $executeBackup = false;
                        } 
                        if($executeBackup === true) {
                            $semaphore = new SemaphoreCommand;
                            if($semaphore->getSemaphore() === false) {
                                $error = tl::tl("Couldn't retrieve lock.");
                            }
                            else {
                                $backup->saveCfgs($cmd[1], $post, $error);
                                $semaphore->releaseSemaphore();
                            }
                        }
                    }
                    break;
                case MainBackup::saveInnovaphoneLogs:
                    if($allowedTime) {
                        $executeBackup = true;
                        if($timeCmd === true && file_exists(Config::webRoot."/".Config::tmpBackupSerials.MainBackup::saveInnovaphoneLogs)) {
                            $contentFile = file(Config::webRoot."/".Config::tmpBackupSerials.MainBackup::saveInnovaphoneLogs);
                            $actualTime = $backup->getDate();
                            $fileTime = $contentFile[1];
                            if(!strncmp($actualTime, $fileTime, 14))
                                $executeBackup = false;
                        } 
                        if($executeBackup === true) {
                            $backup->saveLogs($cmd[1], $post, $error);
                        }
                    }
                    break;
                case MainBackup::cmdTimes:       // checks if further commands can be executed now
                    $allowedTime = false;
                    $allowedHour = false;
                    $allowedDay = false;
                    /* Hours */
                    $patternHour = "/hour:[0-9,]+/";
                    preg_match($patternHour, $cmd[1], $matchesHours);
                    if(!count($matchesHours))
                        preg_match($patternHour, $cmd[2], $matchesHours);
                    /* Days */
                    $patternDays = "/day:[0-9,]+/";
                    preg_match($patternDays, $cmd[2], $matchesDays);
                    if(!count($matchesDays))
                        preg_match($patternDays, $cmd[1], $matchesDays);
                    /* Check */
                    if(!count($matchesHours) && !count($matchesDays)) {
                        echo "empty time settings. Please specified hours and/or days\n";
                    } else {
                        if(!count($matchesHours[0])) {
                            $allowedHour = true;
                        } else {
                            $backupHours = explode(",", substr($matchesHours[0], strpos($matchesHours[0], ":") + 1));
                            $currentHour = date("H");
                            foreach($backupHours as $hour) {
                                if($currentHour == $hour) {
                                    $allowedHour = true;
                                    break;
                                }
                            }
                        }
                        if(!count($matchesDays[0])) {
                            $allowedDay = true;
                        } else {
                            $backupDays = explode(",", substr($matchesDays[0], strpos($matchesDays[0], ":") + 1));
                            $currentDay = date("N");    // ISO-8601 numeric representation of the day of the week (added in PHP 5.1.0)
                            foreach($backupDays as $day) {
                                if($currentDay == $day) {
                                    $allowedDay = true;
                                    break;
                                }
                            }
                        }
                        $allowedTime = ($allowedHour && $allowedDay);
                        if(!$allowedTime) {
                            echo "time settings does not match current hour=$currentHour and day=$currentDay\n";
                        } else {
                            echo "current hour=$currentHour and day=$currentDay found in times command\n";
                            $timeCmd = true;
                        }
                    }
                    break;
                default:
                    if($allowedTime) {
                        global $mainSession;
                        
                        $executeBackup = true;
                        $app = null;
                        if($timeCmd === true && preg_match('/save(.*)(cfgs|logs|db)/', $cmd[0], $matches)) {
                            $serial = Config::webRoot."/".Config::applicationsDir."/".$matches[1]."/".Config::tmpBackupSerials.$cmd[0];
                            $app = $mainSession->getApp($matches[1]);
                            if(isset($app)) {    // Application installed?
                                if(file_exists($serial)) {    // Application installed, file does not exist yet
                                    $contentFile = file($serial);
                                    $actualTime = $backup->getDate();
                                    $fileTime = $contentFile[1];
                                    if(!strncmp($actualTime, $fileTime, 14))
                                        $executeBackup = false;
                                }
                            } else $executeBackup = false;
                        }
                        if($executeBackup === true) {
                            $semaphore = new SemaphoreCommand;
                            if($semaphore->getSemaphore() === false) {
                                $error = tl::tl("Couldn't retrieve lock.");
                            }
                            else {
                                $backup->saveDefaultCmd($cmd[1], $cmd[0], $post, $error);
                                $semaphore->releaseSemaphore();
                            }
                        }
                    }
                    break;
            }
            if($error != "") {
                send_alarm("Backup {$cmd[0]} failed", $error, Alarms::alBackupFailed);
                $backup->error("Backup {$cmd[0]} failed: $error", $post);
            }
            else {
                clear_alarm(Alarms::alBackupFailed);
            }
        }
    }
    echo $backup->getDate().": backup script finished\n";
}

function check_response($response, $c, &$errorNo) {
    if($response === false) {
        $errorNo = curl_errno($c);
        return "(".$errorNo.") ".curl_error($c);
    }
    else {
        $code = curl_getinfo($c, CURLINFO_HTTP_CODE);
        $response = str_replace("\r", "", $response);
        if($code != "200" && $code != "201") {
            $lines = explode("\n", $response, 2);
            return $lines[0];
        }
    }
    return false;
}

backup();
global $mainSession;
$mainSession->destroy();
?>
